## insighttoolkit5 5.4.5

=== Modules/ThirdParty/Eigen3/CMakeLists.txt ===
project(ITKEigen3)
set(ITKEigen3_THIRD_PARTY 1)

option(ITK_USE_SYSTEM_EIGEN "Use an outside build of Eigen3." ${ITK_USE_SYSTEM_LIBRARIES})
mark_as_advanced(ITK_USE_SYSTEM_EIGEN)

if(ITK_USE_SYSTEM_EIGEN)
  set(_eigen_itk_target Eigen3::Eigen)
else()
  set(_eigen_itk_target ITKInternalEigen3::Eigen)
endif()
set(ITKEigen3_LIBRARIES ${_eigen_itk_target})
# Assume that Eigen generates a Eigen3Config.cmake
set(_Eigen3_min_version 3.3)

# Docs:
# find_package(ITK REQUIRED COMPONENTS
# ITKEigen3
# )
# When this module is required, the following cmake is invoked:
# find_package(Eigen3 CONFIG) if ITK_USE_SYSTEM_EIGEN=ON
# Or
# find_package(ITKInternalEigen3 CONFIG) otherwise
#
# ITKInternalEigen3 does NOT allow the use of #include <Eigen/Core>, it requires #include <itkeigen/Eigen/Core>
# This logic is handled automatically by the macro used internally `#include ITK_EIGEN(Core)`

# However, this does not scale well for external ITK modules that want
# to link to third party libraries which are already using Eigen3.
# To solve it, ITK also creates a Eigen3Config.cmake for external consumers (i.e. in ExternalModules).
# This Eigen3Config in ITK/Modules points to the same internal headers than ITKInternalEigen,
# but #include <Eigen/Core> can now be used.
#
# External consumers just need the following extra logic to reuse the internal ITK Eigen, but
# without any change on the include of Eigen3 headers:
#
# Minimal Example:
# CMakeLists.txt
#
# find_package(ITK REQUIRED COMPONENTS
#   ITKEigen3
#   ITKCommon
# )
# set(ITK_EIGEN_LIBRARIES "") # No extra libraries are required if ITK is using system Eigen3
# if(DEFINED ITKInternalEigen3_DIR) # Equivalent to if(NOT ITK_USE_SYSTEM_EIGEN)
#   set(Eigen3_DIR ${ITKInternalEigen3_DIR})
#   find_package(Eigen3 REQUIRED CONFIG)
# endif()
# add_executable(script file_with_itk_and_eigen3.cpp)
# target_link_library(script ${ITK_LIBRARIES})
# target_link_library(script Eigen3::Eigen)

if(ITK_USE_SYSTEM_EIGEN)
  set(_Eigen3_SYSTEM_OR_INTERNAL "Eigen3")
  find_package(${_Eigen3_SYSTEM_OR_INTERNAL} REQUIRED CONFIG)
  set(Eigen3_DIR_INSTALL ${Eigen3_DIR})
  set(Eigen3_DIR_BUILD ${Eigen3_DIR})
else()
  set(_Eigen3_SYSTEM_OR_INTERNAL "ITKInternalEigen3")
  find_package(${_Eigen3_SYSTEM_OR_INTERNAL} REQUIRED CONFIG)
  set(Eigen3_DIR_INSTALL "\${ITK_MODULES_DIR}")
  set(_eigen3_build_dir "${ITK_BINARY_DIR}/ITKInternalEigen3-build")
  set(Eigen3_DIR_BUILD "${_eigen3_build_dir}")
endif()
if(${_Eigen3_SYSTEM_OR_INTERNAL}_VERSION VERSION_LESS ${_Eigen3_min_version})
  message(FATAL_ERROR "Eigen3 version ${_Eigen3_min_version} or later is required.")
endif()

# Eigen3 is header only, but there are compile definitions that we want to provide
# to enforce use of MPL only code, and to disable warnings.
# We only need to add the location of the header itk_eigen.h used internally.
get_target_property(Eigen_INCLUDE_DIRS ${_eigen_itk_target} INTERFACE_INCLUDE_DIRECTORIES)
set(ITKEigen3_INCLUDE_DIRS
  ${Eigen_INCLUDE_DIRS}
  ${ITKEigen3_BINARY_DIR}/src # For the generated itk_eigen.h
  )

# When this module is loaded by an app, load Eigen too.
# Load ITKInternalEigen3 or Eigen3 depending on ITK_USE_SYSTEM_EIGEN
set(ITKEigen3_EXPORT_CODE_INSTALL "
set(ITK_USE_SYSTEM_EIGEN \"${ITK_USE_SYSTEM_EIGEN}\")
set(${_Eigen3_SYSTEM_OR_INTERNAL}_DIR \"${Eigen3_DIR_INSTALL}\")
find_package(${_Eigen3_SYSTEM_OR_INTERNAL} REQUIRED CONFIG)
if(${_Eigen3_SYSTEM_OR_INTERNAL}_VERSION VERSION_LESS ${_Eigen3_min_version})
  message(FATAL_ERROR \"Eigen3 version ${_Eigen3_min_version} or later is required.\")
endif()
")
set(ITKEigen3_EXPORT_CODE_BUILD "
set(ITK_USE_SYSTEM_EIGEN \"${ITK_USE_SYSTEM_EIGEN}\")
set(${_Eigen3_SYSTEM_OR_INTERNAL}_DIR \"${Eigen3_DIR_BUILD}\")
find_package(${_Eigen3_SYSTEM_OR_INTERNAL} REQUIRED CONFIG)
if(${_Eigen3_SYSTEM_OR_INTERNAL}_VERSION VERSION_LESS ${_Eigen3_min_version})
  message(FATAL_ERROR \"Eigen3 version ${_Eigen3_min_version} or later is required.\")
endif()
")

# Eigen3 targets are not installed if ITK_USE_SYSTEM_EIGEN==True
itk_module_impl()

configure_file(src/itk_eigen.h.in src/itk_eigen.h)
install(FILES ${ITKEigen3_BINARY_DIR}/src/itk_eigen.h
  DESTINATION ${ITKEigen3_INSTALL_INCLUDE_DIR}
  COMPONENT Development
  )

=== Modules/Core/Common/src/CMakeLists.txt ===
include(GetGitRevisionDescription)
get_git_head_revision(GIT_CONFIG_REFSPEC GIT_CONFIG_SHA1)
git_describe(GIT_VERSION_DESC)
git_head_date(GIT_CONFIG_DATE)
git_head_localmods(GIT_LOCAL_MODIFICATIONS)
if(GIT_LOCAL_MODIFICATIONS MATCHES ".*files changed.*")
  set(GIT_LOCAL_MODIFICATIONS " (with uncommitted code modifications ${GIT_LOCAL_MODIFICATIONS})")
endif()

string(TIMESTAMP CONFIGURE_DATE "%Y-%m-%d %H:%M" UTC)

## MAKE_MAP_ENTRY is a macro to facilitate placing items in the itk::BuildInformation class
##                /--------------------------_---------------------------_-------------------------------------------------/
##                |    KEY                   |    VALUE                  | Description of value                            |
##                \--------------------------\---------------------------\-------------------------------------------------\
set(MAPPING_VALUES
    "
  MAKE_MAP_ENTRY( \"PROJECT_URL\",           \"https://www.itk.org\",      \"The URL of project.\"                     );
  MAKE_MAP_ENTRY( \"VERSION\",               \"${ITK_VERSION}\"    ,      \"The version at configuration time.\"      );
  MAKE_MAP_ENTRY( \"CONFIGURE_DATE\",        \"${CONFIGURE_DATE}\",       \"The date of configuration.\"              );

  MAKE_MAP_ENTRY( \"GIT_CONFIG_SHA1\",       \"${GIT_CONFIG_SHA1}${GIT_LOCAL_MODIFICATIONS}\",
                                                                               \"The git HEAD SHA1 has at configuration.\");
  MAKE_MAP_ENTRY( \"GIT_CONFIG_REFSPEC\",    \"${GIT_CONFIG_REFSPEC}\",   \"The git HEAD ref spec.\"                  );
  MAKE_MAP_ENTRY( \"GIT_CONFIG_DATE\",       \"${GIT_CONFIG_DATE}\",      \"The git HEAD date\"                       );
  MAKE_MAP_ENTRY( \"GIT_VERSION_DESC\",      \"${GIT_VERSION_DESC}\",     \"The git HEAD version tag-commits-hash\"   );

  MAKE_MAP_ENTRY( \"CMAKE_VERSION\",         \"${CMAKE_VERSION}\",        \"The version of cmake used to configure.\");
  MAKE_MAP_ENTRY( \"CMAKE_GENERATOR\",       \"${CMAKE_GENERATOR}\",      \"The generator used for building.\"        );
  MAKE_MAP_ENTRY( \"CMAKE_BUILD_TYPE\",      \"${CMAKE_BUILD_TYPE}\",     \"The build type requested.\"               );

  MAKE_MAP_ENTRY( \"CMAKE_C_COMPILER_ID\",   \"${CMAKE_C_COMPILER_ID}\",  \"The C compiler ID used for building.\"    );
  MAKE_MAP_ENTRY( \"CMAKE_C_COMPILER_VERSION\",   \"${CMAKE_C_COMPILER_VERSION}\",
                                                                          \"The C compiler version used for building.\"    );
  MAKE_MAP_ENTRY( \"CMAKE_C_COMPILER\",      \"${CMAKE_C_COMPILER}\",     \"The C compiler.\"                       );
  MAKE_MAP_ENTRY( \"CMAKE_C_FLAGS\",         \"${CMAKE_C_FLAGS} ${CMAKE_CXX_FLAGS_${CMAKE_BUILD_TYPE}}\",
                                                                          \"The C compiler flags.\"                 );

  MAKE_MAP_ENTRY( \"CMAKE_CXX_STANDARD\",    \"${CMAKE_CXX_STANDARD}\",   \"The CXX standard specified.\"             );
  MAKE_MAP_ENTRY( \"CMAKE_CXX_COMPILER_ID\", \"${CMAKE_CXX_COMPILER_ID}\",\"The CXX compiler ID used for building.\"  );
  MAKE_MAP_ENTRY( \"CMAKE_CXX_COMPILER_VERSION\",   \"${CMAKE_CXX_COMPILER_VERSION}\",
                                                                          \"The CXX compiler version used for building.\"  );
  MAKE_MAP_ENTRY( \"CMAKE_CXX_COMPILER\",    \"${CMAKE_CXX_COMPILER}\",   \"The CXX compiler.\"                       );
  MAKE_MAP_ENTRY( \"CMAKE_CXX_FLAGS\",       \"${CMAKE_CXX_FLAGS} ${CMAKE_CXX_FLAGS_${CMAKE_BUILD_TYPE}}\",
                                                                          \"The CXX compiler flags.\"                 );
")

configure_file(itkBuildInformation.cxx.in ${ITKCommon_BINARY_DIR}/itkBuildInformation.cxx)
#[COPYONLY] [ESCAPE_QUOTES] [@ONLY]
#[NEWLINE_STYLE [UNIX|DOS|WIN32|LF|CRLF] ])

set(ITKCommon_SRCS
    ${ITKCommon_BINARY_DIR}/itkBuildInformation.cxx
    itkCommonEnums.cxx
    itkMemoryProbesCollectorBase.cxx
    itkCreateObjectFunction.cxx
    itkLogger.cxx
    itkLogOutput.cxx
    itkLoggerOutput.cxx
    itkProgressAccumulator.cxx
    itkTotalProgressReporter.cxx
    itkNumericTraits.cxx
    itkHexahedronCellTopology.cxx
    itkIndent.cxx
    itkEventObject.cxx
    itkFileOutputWindow.cxx
    itkSimpleFilterWatcher.cxx
    itkNumericTraitsVectorPixel.cxx
    itkObject.cxx
    itkQuadrilateralCellTopology.cxx
    itkIterationReporter.cxx
    itkMemoryProbe.cxx
    itkTextOutput.cxx
    itkNumericTraitsTensorPixel2.cxx
    itkNumericTraitsFixedArrayPixel2.cxx
    itkProcessObject.cxx
    itkStreamingProcessObject.cxx
    itkSpatialOrientationAdapter.cxx
    itkRealTimeInterval.cxx
    itkOctreeNode.cxx
    itkNumericTraitsFixedArrayPixel.cxx
    itkMultiThreaderBase.cxx
    itkPlatformMultiThreader.cxx
    itkMetaDataObject.cxx
    itkMetaDataDictionary.cxx
    itkDataObject.cxx
    itkThreadLogger.cxx
    itkNumericTraitsTensorPixel.cxx
    itkCommand.cxx
    itkNumericTraitsPointPixel.cxx
    itkLightObject.cxx
    itkStdStreamLogOutput.cxx
    itkLightProcessObject.cxx
    itkRegion.cxx
    itkImageIORegion.cxx
    itkImageSourceCommon.cxx
    itkImageToImageFilterCommon.cxx
    itkImageRegionSplitterBase.cxx
    itkImageRegionSplitterSlowDimension.cxx
    itkImageRegionSplitterDirection.cxx
    itkImageRegionSplitterMultidimensional.cxx
    itkVersion.cxx
    itkNumericTraitsRGBAPixel.cxx
    itkRealTimeClock.cxx
    itkMetaDataObjectBase.cxx
    itkCovariantVector.cxx
    itkMemoryUsageObserver.cxx
    itkMersenneTwisterRandomVariateGenerator.cxx
    itkLoggerBase.cxx
    itkNumericTraitsCovariantVectorPixel.cxx
    itkProgressReporter.cxx
    itkExceptionObject.cxx
    itkMultipleLogOutput.cxx
    itkQuadraticTriangleCellTopology.cxx
    itkTimeProbesCollectorBase.cxx
    itkSmapsFileParser.cxx
    itkTriangleCellTopology.cxx
    itkVector.cxx
    itkRealTimeStamp.cxx
    itkDirectory.cxx
    itkLoggerManager.cxx
    itkTimeProbe.cxx
    itkNumericTraitsRGBPixel.cxx
    itkTimeStamp.cxx
    itkSingleton.cxx
    itkTetrahedronCellTopology.cxx
    itkThreadedIndexedContainerPartitioner.cxx
    itkObjectFactoryBase.cxx
    itkFloatingPointExceptions.cxx
    itkOutputWindow.cxx
    itkNumericTraitsDiffusionTensor3DPixel.cxx
    itkEquivalencyTable.cxx
    itkXMLFileOutputWindow.cxx
    itkXMLFilterWatcher.cxx
    itkStoppingCriterionBase.cxx
    itkCompensatedSummation.cxx
    itkArrayOutputSpecialization.cxx
    itkNumberToString.cxx
    itkRandomVariateGeneratorBase.cxx
    itkMath.cxx
    itkProgressTransformer.cxx
    itkSymmetricEigenAnalysis.cxx
    itkExtractImageFilter.cxx
    itkLoggerThreadWrapper.cxx
    itkFrustumSpatialFunction.cxx
    itkObjectStore.cxx
    itkGaussianDerivativeOperator.cxx
    itkSpatialOrientation.cxx
  itkAnatomicalOrientation.cxx
)

if(WIN32)
  list(APPEND ITKCommon_SRCS itkWin32OutputWindow.cxx)
endif()
if(ITK_USE_WIN32_THREADS OR ITK_USE_PTHREADS)
  list(
    APPEND
    ITKCommon_SRCS
    itkPoolMultiThreader.cxx
    itkThreadPool.cxx)
endif()

if(ITK_DYNAMIC_LOADING)
  list(APPEND ITKCommon_SRCS itkDynamicLoader.cxx)
endif()

if(ITK_USE_TBB)
  list(APPEND ITKCommon_SRCS itkTBBMultiThreader.cxx)
endif()

# Prevent optimization from affecting the floating point calculation.
if(CMAKE_CXX_COMPILER MATCHES "^icc")
  if(WIN32)
    set_source_files_properties(itkCompensatedSummation.cxx PROPERTIES COMPILE_FLAGS /fp precise)
  else()
    set_source_files_properties(itkCompensatedSummation.cxx PROPERTIES COMPILE_FLAGS -fp-model precise)
  endif()
elseif(CMAKE_COMPILER_IS_GNUCXX)
  # -fno-associative-math appears to only be present in GCC 4.3 onwards.
  include(CheckCXXCompilerFlag)
  check_cxx_compiler_flag(-fno-associative-math gcc_has_no_associative_math)
  if(gcc_has_no_associative_math)
    set_source_files_properties(itkCompensatedSummation.cxx PROPERTIES COMPILE_FLAGS -fno-associative-math)
  else()
    set_source_files_properties(itkCompensatedSummation.cxx PROPERTIES COMPILE_FLAGS -fno-unsafe-math-optimizations)
  endif()
elseif(MSVC)
  set_source_files_properties(itkCompensatedSummation.cxx PROPERTIES COMPILE_FLAGS -fp:precise)
endif()

### generating libraries
itk_module_add_library(ITKCommon ${ITKCommon_SRCS})

target_link_libraries(
  ITKCommon
  LINK_PUBLIC
  itksys
  ITKVNLInstantiation)

if(UNIX)
  target_link_libraries(
    ITKCommon
    LINK_PUBLIC
    ${CMAKE_THREAD_LIBS}
    -lm)
  if(ITK_DYNAMIC_LOADING)
    target_link_libraries(ITKCommon LINK_PUBLIC ${CMAKE_DL_LIBS})
  endif()
endif()

if(ITK_USE_TBB)
  # https://software.intel.com/en-us/node/506139
  # The macro TBB_DEPRECATED controls deprecated features.
  #      Define it to 0 to remove deprecated Intel® Threading Building Blocks (Intel® TBB) 2.1 interfaces.
  target_compile_definitions(ITKCommon PUBLIC TBB_DEPRECATED=0)
  # The macro TBB_USE_CAPTURED_EXCEPTION controls rethrow of exceptions within the library.
  #      Define TBB_USE_CAPTURED_EXCEPTION=0 to request rethrow of the exact exception.
  target_compile_definitions(ITKCommon PUBLIC TBB_USE_CAPTURED_EXCEPTION=0)
endif()

=== Modules/Core/Common/test/CMakeLists.txt ===
itk_module_test()
set(ITKCommon1Tests
    itkImageRegionExplicitTest.cxx
    itkAbortProcessObjectTest.cxx
    itkCommandObserverObjectTest.cxx
    itkAdaptorComparisonTest.cxx
    itkCovariantVectorGeometryTest.cxx
    itkDataTypeTest.cxx
    itkDecoratorTest.cxx
    itkExtractImage3Dto2DTest.cxx
    itkExtractImageTest.cxx
    itkFilterDispatchTest.cxx
    itkFloodFilledSpatialFunctionTest.cxx
    itkFloodFillIteratorTest.cxx
    itkGaussianDerivativeOperatorTest.cxx
    itkMapContainerTest.cxx
    itkVectorContainerTest.cxx
    itkIteratorTests.cxx
    itkImageReverseIteratorTest.cxx
    itkImageComputeOffsetAndIndexTest.cxx
    itkImageDuplicatorTest.cxx
    itkImageDuplicatorTest2.cxx
    itkImageIteratorsForwardBackwardTest.cxx
    itkImageLinearIteratorTest.cxx
    itkImageAdaptorPipeLineTest.cxx
    itkImportContainerTest.cxx
    itkImportImageTest.cxx
    itkImageRandomIteratorTest.cxx
    itkImageRandomIteratorTest2.cxx
    itkImageRandomNonRepeatingIteratorWithIndexTest.cxx
    itkImageRandomNonRepeatingIteratorWithIndexTest2.cxx
    itkImageSliceIteratorTest.cxx
    itkRGBPixelTest.cxx
    itkLightObjectTest.cxx
    itkBoundingBoxTest.cxx
    itkBoundaryConditionTest.cxx
    itkByteSwapTest.cxx
    itkSparseImageTest.cxx
    itkSimpleFilterWatcherTest.cxx
    itkSymmetricEllipsoidInteriorExteriorSpatialFunctionTest.cxx
    itkSymmetricSecondRankTensorImageReadTest.cxx
    itkSymmetricSecondRankTensorImageWriteReadTest.cxx
    itkArray2DTest.cxx
    itkFloatingPointExceptionsTest.cxx
    itkFixedArrayTest2.cxx
    itkNeighborhoodAlgorithmTest.cxx
    itkPhasedArray3DSpecialCoordinatesImageTest.cxx
    itkPriorityQueueTest.cxx
    itkFileOutputWindowTest.cxx
    itkSymmetricEigenAnalysisTest.cxx
    itkStreamingImageFilterTest.cxx
    itkStreamingImageFilterTest2.cxx
    itkStreamingImageFilterTest3.cxx
    itkLoggerTest.cxx
    itkDerivativeOperatorTest.cxx
    itkColorTableTest.cxx
    itkNumericTraitsTest.cxx
    itkImageRegionTest.cxx
    itkExceptionObjectTest.cxx
    itkNeighborhoodOperatorTest.cxx
    itkNumericsTest.cxx
    itkAnnulusOperatorTest.cxx
    itkLineIteratorTest.cxx
    itkGaussianSpatialFunctionTest.cxx
    itkRealTimeClockTest.cxx
    itkRealTimeIntervalTest.cxx
    itkRealTimeStampTest.cxx
    itkTimeStampTest.cxx
    itkIntTypesTest.cxx
    itkBSplineKernelFunctionTest.cxx
    itkArrayTest.cxx
    itkImageIteratorTest.cxx
    itkImageRegionIteratorTest.cxx
    itkImageScanlineIteratorTest1.cxx
    itkCrossHelperTest.cxx
    itkImageIteratorWithIndexTest.cxx
    itkDirectoryTest.cxx
    itkObjectStoreTest.cxx
    itkObjectFactoryTest.cxx
    itkEventObjectTest.cxx
    itkMathCastWithRangeCheckTest.cxx
    itkMathRoundProfileTest1.cxx
    itkMathRoundTest.cxx
    itkMathRoundTest2.cxx
    itkModifiedTimeTest.cxx
    itkMultipleLogOutputTest.cxx
    itkVectorTest.cxx
    itkImageTest.cxx
    itkPointSetTest.cxx
    itkPointSetToImageFilterTest1.cxx
    itkPointSetToImageFilterTest2.cxx
    itkBresenhamLineTest.cxx
    itkSparseFieldLayerTest.cxx
    itkDataObjectTest.cxx
    itkAtanRegularizedHeavisideStepFunctionTest1.cxx
    itkHashTableTest.cxx
    itkHeavisideStepFunctionTest1.cxx
    itkSinRegularizedHeavisideStepFunctionTest1.cxx
    itkPixelAccessTest.cxx
    itkPointGeometryTest.cxx
    itkMersenneTwisterRandomVariateGeneratorTest.cxx
    itkNumberToStringTest.cxx
    itkTimeProbeTest.cxx
    itkTimeProbeTest2.cxx
    itkSpatialOrientationTest.cxx
    itkStdStreamStateSaveTest.cxx
    itkVersionTest.cxx
    VNLSparseLUSolverTraitsTest.cxx
    itkSobelOperatorImageConvolutionTest.cxx
    itkSobelOperatorImageFilterTest.cxx
    itkSobelOperatorTest.cxx)
set(ITKCommon2Tests
    itkSTLThreadTest.cxx
    itkThreadedIndexedContainerPartitionerTest.cxx
    itkThreadedIteratorRangePartitionerTest.cxx
    itkThreadedIteratorRangePartitionerTest2.cxx
    itkThreadedIteratorRangePartitionerTest3.cxx
    itkThreadedImageRegionPartitionerTest.cxx
    itkThreadLoggerTest.cxx
    itkLoggerThreadWrapperTest.cxx
    itkThreadDefsTest.cxx
    itkMultiThreaderBaseTest.cxx
    itkMultiThreaderTypeFromEnvironmentTest.cxx
    itkMultiThreadingEnvironmentTest.cxx
    itkMultiThreaderParallelizeArrayTest.cxx
    itkMultithreadingTest.cxx
    itkMultiThreaderExceptionsTest.cxx
    itkMetaProgrammingLibraryTest.cxx
    itkPromoteType.cxx
    itkMetaDataDictionaryTest.cxx
    itkStdStreamLogOutputTest.cxx
    itkOctreeTest.cxx
    itkTimeProbesTest.cxx
    itkVariableLengthVectorTest.cxx
    itkSpatialFunctionTest.cxx
    itkPeriodicBoundaryConditionTest.cxx
    itkSmartPointerTest.cxx
    itkVariableSizeMatrixTest.cxx
    itkConicShellInteriorExteriorSpatialFunctionTest.cxx
    itkEllipsoidInteriorExteriorSpatialFunctionTest.cxx
    itkFrustumSpatialFunctionTest.cxx
    itkTorusInteriorExteriorSpatialFunctionTest.cxx
    itkConstNeighborhoodIteratorTest.cxx
    itkShapedNeighborhoodIteratorTest.cxx
    itkMatrixTest.cxx
    itkAutoPointerTest.cxx
    itkNeighborhoodIteratorTest.cxx
    itkLoggerManagerTest.cxx
    itkBSplineInterpolationWeightFunctionTest.cxx
    itkSymmetricSecondRankTensorTest.cxx
    itkConstShapedNeighborhoodIteratorTest.cxx
    itkConstShapedNeighborhoodIteratorTest2.cxx
    itkSTLContainerAdaptorTest.cxx
    itkFiniteCylinderSpatialFunctionTest.cxx
    itkLoggerOutputTest.cxx
    itkNeighborhoodTest.cxx
    itkVersorTest.cxx
    itkObjectFactoryTest2.cxx
    itkObjectFactoryTest3.cxx
    itkObjectFactoryOnlyNewTest.cxx
    itkMinimumMaximumImageCalculatorTest.cxx
    itkSliceIteratorTest.cxx
    itkImageRegionExclusionIteratorWithIndexTest.cxx
    itkFixedArrayTest.cxx
    itkImageTransformTest.cxx
    itkImageFillBufferTest.cxx
    itkMemoryLeakTest.cxx
    itkVectorGeometryTest.cxx
    itkVNLRoundProfileTest1.cxx
    itkZeroFluxBoundaryConditionTest.cxx
    itkMemoryProbesCollecterBaseTest.cxx
    itkImageAlgorithmCopyTest.cxx
    itkImageAlgorithmCopyTest2.cxx
    itkConstantBoundaryConditionTest.cxx
    itkDataObjectAndProcessObjectTest.cxx
    itkOptimizerParametersTest.cxx
    itkImageVectorOptimizerParametersHelperTest.cxx
    itkCompensatedSummationTest.cxx
    itkCompensatedSummationTest2.cxx
    itkImageRegionConstIteratorWithOnlyIndexTest.cxx
    itkImageRandomConstIteratorWithOnlyIndexTest.cxx
    itkConstNeighborhoodIteratorWithOnlyIndexTest.cxx
    itkImageToImageToleranceTest.cxx
    itkImageRegionSplitterSlowDimensionTest.cxx
    itkImageRegionSplitterDirectionTest.cxx
    itkImageRegionSplitterMultidimensionalTest.cxx
    itkMetaDataObjectTest.cxx
    # itkVectorMultiplyTest.cxx
    itkXMLFileOutputWindowTest.cxx
    itkXMLFilterWatcherTest.cxx)

if(ITK_BUILD_SHARED_LIBS AND ITK_DYNAMIC_LOADING)
  list(APPEND ITKCommon2Tests itkDownCastTest.cxx)
endif()

# Note: Tests are arbitrarily split into two drivers to avoid memory issues.
createtestdriver(
  ITKCommon1
  "${ITKCommon-Test_LIBRARIES}"
  "${ITKCommon1Tests}"
  itkFloatingPointExceptionsExtern.cxx)
createtestdriver(
  ITKCommon2
  "${ITKCommon-Test_LIBRARIES}"
  "${ITKCommon2Tests}"
  itkFloatingPointExceptionsExtern.cxx)

set(BASELINE "${ITK_DATA_ROOT}/Baseline/Common")
set(TEMP ${ITK_TEST_OUTPUT_DIR})

add_executable(itkMathTest itkMathTest.cxx)
target_link_options(itkMathTest PRIVATE "$<$<AND:$<C_COMPILER_ID:AppleClang>,$<VERSION_GREATER_EQUAL:$<C_COMPILER_VERSION>,15.0>>:LINKER:-no_warn_duplicate_libraries>")
itk_module_target_label(itkMathTest)
target_link_libraries(itkMathTest LINK_PUBLIC ${ITKCommon_LIBRARIES})
itk_add_test(
  NAME
  itkMathTest
  COMMAND
  itkMathTest)

add_executable(itkSystemInformation itkSystemInformation.cxx)
target_link_options(itkSystemInformation PRIVATE "$<$<AND:$<C_COMPILER_ID:AppleClang>,$<VERSION_GREATER_EQUAL:$<C_COMPILER_VERSION>,15.0>>:LINKER:-no_warn_duplicate_libraries>")
itk_module_target_label(itkSystemInformation)
target_link_libraries(itkSystemInformation LINK_PUBLIC ${ITKCommon_LIBRARIES})
itk_add_test(
  NAME
  SystemInformation
  COMMAND
  itkSystemInformation)

itk_add_test(
  NAME
  itkVersionTest
  COMMAND
  ITKCommon1TestDriver
  itkVersionTest)

if(ITK_BUILD_SHARED_LIBS)
  ## Create a library to test ITK loadable factories
  set(FactoryTest_Source itkFactoryTestLib.cxx)
  add_library(FactoryTestLib MODULE ${FactoryTest_Source})
  itk_module_target_label(FactoryTestLib)
  target_link_libraries(FactoryTestLib LINK_PUBLIC ${ITKCommon_LIBRARIES})
  set_property(TARGET FactoryTestLib PROPERTY LIBRARY_OUTPUT_DIRECTORY ${ITK_TEST_OUTPUT_DIR})
  add_dependencies(ITKCommon2TestDriver FactoryTestLib)
endif()

itk_add_test(
  NAME
  itkAbortProcessObjectTest
  COMMAND
  ITKCommon1TestDriver
  itkAbortProcessObjectTest)
itk_add_test(
  NAME
  itkCommandObserverObjectTest
  COMMAND
  ITKCommon1TestDriver
  itkCommandObserverObjectTest)
itk_add_test(
  NAME
  itkAdaptorComparisonTest
  COMMAND
  ITKCommon1TestDriver
  itkAdaptorComparisonTest)
itk_add_test(
  NAME
  itkThreadedIndexedContainerPartitionerTest
  COMMAND
  ITKCommon2TestDriver
  itkThreadedIndexedContainerPartitionerTest)
itk_add_test(
  NAME
  itkThreadedIteratorRangePartitionerTest
  COMMAND
  ITKCommon2TestDriver
  itkThreadedIteratorRangePartitionerTest)
itk_add_test(
  NAME
  itkThreadedIteratorRangePartitionerTest2
  COMMAND
  ITKCommon2TestDriver
  itkThreadedIteratorRangePartitionerTest2)
itk_add_test(
  NAME
  itkThreadedIteratorRangePartitionerTest3
  COMMAND
  ITKCommon2TestDriver
  itkThreadedIteratorRangePartitionerTest3)

itk_add_test(
  NAME
  itkImageAdaptorPipeLineTest
  COMMAND
  ITKCommon1TestDriver
  itkImageAdaptorPipeLineTest)
itk_add_test(
  NAME
  itkThreadedImageRegionPartitionerTest
  COMMAND
  ITKCommon2TestDriver
  itkThreadedImageRegionPartitionerTest)
itk_add_test(
  NAME
  itkImportContainerTest
  COMMAND
  ITKCommon1TestDriver
  itkImportContainerTest)
itk_add_test(
  NAME
  itkImportImageTest
  COMMAND
  ITKCommon1TestDriver
  itkImportImageTest)
itk_add_test(
  NAME
  itkCovariantVectorGeometryTest
  COMMAND
  ITKCommon1TestDriver
  itkCovariantVectorGeometryTest)
itk_add_test(
  NAME
  itkDataTypeTest
  COMMAND
  ITKCommon1TestDriver
  itkDataTypeTest)
itk_add_test(
  NAME
  itkDecoratorTest
  COMMAND
  ITKCommon1TestDriver
  itkDecoratorTest)
itk_add_test(
  NAME
  itkExtractImage3Dto2DTest
  COMMAND
  ITKCommon1TestDriver
  itkExtractImage3Dto2DTest)
itk_add_test(
  NAME
  itkExtractImageTest
  COMMAND
  ITKCommon1TestDriver
  itkExtractImageTest)
itk_add_test(
  NAME
  itkFilterDispatchTest
  COMMAND
  ITKCommon1TestDriver
  itkFilterDispatchTest)
itk_add_test(
  NAME
  itkFloodFilledSpatialFunctionTest
  COMMAND
  ITKCommon1TestDriver
  itkFloodFilledSpatialFunctionTest)
itk_add_test(
  NAME
  itkFloodFillIteratorTest
  COMMAND
  ITKCommon1TestDriver
  itkFloodFillIteratorTest)
itk_add_test(
  NAME
  itkAnnulusOperatorTest
  COMMAND
  ITKCommon1TestDriver
  itkAnnulusOperatorTest)

itk_add_test(
  NAME
  itkColorTableTest1
  COMMAND
  ITKCommon1TestDriver
  --redirectOutput
  ${TEMP}/itkColorTableTest1.txt
  itkColorTableTest
  8)
set_tests_properties(itkColorTableTest1 PROPERTIES ATTACHED_FILES_ON_FAIL ${TEMP}/itkColorTableTest1.txt)
itk_add_test(
  NAME
  itkColorTableTest2
  COMMAND
  ITKCommon1TestDriver
  --redirectOutput
  ${TEMP}/itkColorTableTest2.txt
  itkColorTableTest
  16)
set_tests_properties(itkColorTableTest2 PROPERTIES ATTACHED_FILES_ON_FAIL ${TEMP}/itkColorTableTest2.txt)

itk_add_test(
  NAME
  itkDirectoryTest
  COMMAND
  ITKCommon1TestDriver
  itkDirectoryTest
  ${TEMP})
itk_add_test(
  NAME
  itkDerivativeOperatorTest
  COMMAND
  ITKCommon1TestDriver
  itkDerivativeOperatorTest)
itk_add_test(
  NAME
  itkMultipleLogOutputTest
  COMMAND
  ITKCommon1TestDriver
  itkMultipleLogOutputTest
  ${TEMP}/test_multi.txt)
itk_add_test(
  NAME
  itkFixedArrayTest
  COMMAND
  ITKCommon2TestDriver
  itkFixedArrayTest)
itk_add_test(
  NAME
  itkImageTransformTest
  COMMAND
  ITKCommon2TestDriver
  itkImageTransformTest)
itk_add_test(
  NAME
  itkMinimumMaximumImageCalculatorTest
  COMMAND
  ITKCommon2TestDriver

=== Wrapping/Generators/Python/Tests/CMakeLists.txt ===
# TODO: drop -E option once all filters/spatial objects/cost functions are actually wrapped
itk_python_add_test(
  NAME
  NonBlockingPythonFilterCoverage
  COMMAND
  ${CMAKE_CURRENT_SOURCE_DIR}/wrappingCoverage.py
  -E
  -b
  Filter
  -e
  ${CMAKE_CURRENT_SOURCE_DIR}/exclude-filters.txt
  ${ITK_INCLUDE_DIRS})
itk_python_add_test(
  NAME
  NonBlockingPythonSpatialObjectCoverage
  COMMAND
  ${CMAKE_CURRENT_SOURCE_DIR}/wrappingCoverage.py
  -E
  -b
  SpatialObject
  ${ITK_INCLUDE_DIRS})
if(ITK_BUILD_DEFAULT_MODULES)
  itk_python_add_test(
    NAME
    NonBlockingPythonCostFunctionCoverage
    COMMAND
    ${CMAKE_CURRENT_SOURCE_DIR}/wrappingCoverage.py
    -E
    -b
    CostFunction
    ${ITK_INCLUDE_DIRS})
  itk_python_add_test(
    NAME
    PythonOptimizerCoverage
    COMMAND
    ${CMAKE_CURRENT_SOURCE_DIR}/wrappingCoverage.py
    -b
    Optimizer
    ${ITK_INCLUDE_DIRS})
endif()

itk_python_add_test(
  NAME
  PythonImageIOCoverage
  COMMAND
  ${CMAKE_CURRENT_SOURCE_DIR}/wrappingCoverage.py
  -b
  ImageIO
  -e
  ${CMAKE_CURRENT_SOURCE_DIR}/exclude-imageio.txt
  ${ITK_INCLUDE_DIRS})
itk_python_add_test(
  NAME
  PythonTransformCoverage
  COMMAND
  ${CMAKE_CURRENT_SOURCE_DIR}/wrappingCoverage.py
  -b
  Transform
  -e
  ${CMAKE_CURRENT_SOURCE_DIR}/exclude-transform.txt
  ${ITK_INCLUDE_DIRS})

itk_python_add_test(
  NAME
  PythonFindEmptyClasses
  COMMAND
  ${CMAKE_CURRENT_SOURCE_DIR}/findEmptyClasses.py)
itk_python_add_test(
  NAME
  PythonGetNameOfClass
  COMMAND
  ${CMAKE_CURRENT_SOURCE_DIR}/getNameOfClass.py)
itk_python_add_test(
  NAME
  PythonTiming
  COMMAND
  ${CMAKE_CURRENT_SOURCE_DIR}/timing.py)
itk_python_add_test(
  NAME
  PythonBuildOptions
  COMMAND
  ${CMAKE_CURRENT_SOURCE_DIR}/build_options.py)
itk_python_add_test(
  NAME
  PythonVerifyGetOutputAPIConsistency
  COMMAND
  ${CMAKE_CURRENT_SOURCE_DIR}/verifyGetOutputAPIConsistency.py)
itk_python_add_test(
  NAME
  PythonVerifyTTypeAPIConsistency
  COMMAND
  ${CMAKE_CURRENT_SOURCE_DIR}/verifyTTypeAPIConsistency.py)
itk_python_add_test(
  NAME
  PythonTypeTest
  COMMAND
  ${CMAKE_CURRENT_SOURCE_DIR}/PythonTypeTest.py)
itk_python_add_test(
  NAME
  PythonComplex
  COMMAND
  ${CMAKE_CURRENT_SOURCE_DIR}/complex.py)
itk_python_add_test(
  NAME
  PythonHelperFunctions
  COMMAND
  ${CMAKE_CURRENT_SOURCE_DIR}/helpers.py)
itk_python_add_test(
  NAME
  PythonLazyModule
  COMMAND
  ${CMAKE_CURRENT_SOURCE_DIR}/lazy.py)
itk_python_add_test(
  NAME
  PythonNoLazyModule
  COMMAND
  ${CMAKE_CURRENT_SOURCE_DIR}/nolazy.py)
itk_python_add_test(
  NAME
  PythonNoDefaultFactories
  COMMAND
  ${CMAKE_CURRENT_SOURCE_DIR}/nodefaultfactories.py)
itk_python_add_test(
  NAME
  PythonDICOMSeries
  COMMAND
  ${CMAKE_CURRENT_SOURCE_DIR}/dicomSeries.py
  DATA{${ITK_DATA_ROOT}/Input/DicomSeries/Image0075.dcm}
  DATA{${ITK_DATA_ROOT}/Input/DicomSeries/Image0076.dcm}
  DATA{${ITK_DATA_ROOT}/Input/DicomSeries/Image0077.dcm})
itk_python_add_test(
  NAME
  PyImageFilterTest
  COMMAND
  ${CMAKE_CURRENT_SOURCE_DIR}/PyImageFilterTest.py)
itk_python_add_test(
  NAME
  PythonConvertMetaData
  COMMAND
  ${CMAKE_CURRENT_SOURCE_DIR}/test_metadata.py
  DATA{${WrapITK_SOURCE_DIR}/images/r16slice.nii.gz}
  DATA{${WrapITK_SOURCE_DIR}/images/sourceImage.nii.gz}
  DATA{${WrapITK_SOURCE_DIR}/images/warp2D.nii.gz}
  DATA{${WrapITK_SOURCE_DIR}/images/warp3D.nii.gz})

# some tests will fail if dim=2 and unsigned short are not wrapped
intersection(WRAP_2 2 "${ITK_WRAP_IMAGE_DIMS}")
if(ITK_WRAP_unsigned_char AND WRAP_2)
  if(ITK_BUILD_DEFAULT_MODULES)
    itk_python_add_test(
      NAME
      PythonTypemapsTest
      COMMAND
      ${CMAKE_CURRENT_SOURCE_DIR}/PythonTypemapsTest.py)
    itk_python_add_test(
      NAME
      PythonTemplateTest
      COMMAND
      ${CMAKE_CURRENT_SOURCE_DIR}/PythonTemplateTest.py)
    itk_python_add_test(
      NAME
      PythonModifiedTimeTest
      COMMAND
      ${CMAKE_CURRENT_SOURCE_DIR}/ModifiedTime.py)
    itk_python_add_test(
      NAME
      PythonTemplatedPipelineTest
      TEST_DRIVER_ARGS
      --compare
      ${ITK_TEST_OUTPUT_DIR}/templated_pipeline.png
      DATA{${WrapITK_SOURCE_DIR}/images/templated_pipeline.png}
      COMMAND
      ${CMAKE_CURRENT_SOURCE_DIR}/templated_pipeline.py
      DATA{${WrapITK_SOURCE_DIR}/images/2th_cthead1.png}
      ${ITK_TEST_OUTPUT_DIR}/templated_pipeline.png
      10)
    itk_python_add_test(
      NAME
      PythonModuleToModuleTest
      COMMAND
      ${CMAKE_CURRENT_SOURCE_DIR}/module2module.py
      DATA{${WrapITK_SOURCE_DIR}/images/cthead1.png}
      5)
    itk_python_add_test(
      NAME
      PythonExtrasTest
      COMMAND
      ${CMAKE_CURRENT_SOURCE_DIR}/extras.py
      DATA{${WrapITK_SOURCE_DIR}/images/cthead1.png}
      DATA{../../../../Testing/Data/Input/mushroom.vtk}
      DATA{../../../../Testing/Data/Input/LinearTransform.h5}
      ${ITK_TEST_OUTPUT_DIR}/out.png
      ${ITK_TEST_OUTPUT_DIR}/extras-mushroom.vtk
      ${ITK_TEST_OUTPUT_DIR}
      ${ITK_TEST_OUTPUT_DIR}/LinearTransformWritten.h5
      ${ExternalData_BINARY_ROOT}/Testing/Data/Input/DicomSeries)
    set_tests_properties(PythonExtrasTest PROPERTIES DEPENDS PythonDICOMSeries)
    itk_python_add_test(
      NAME
      PythonXarrayTest
      COMMAND
      ${CMAKE_CURRENT_SOURCE_DIR}/test_xarray.py
      DATA{${WrapITK_SOURCE_DIR}/images/cthead1.png})
    itk_python_add_test(
      NAME
      PythonImreadSingleFileListTest
      COMMAND
      ${CMAKE_CURRENT_SOURCE_DIR}/test_imread_single_file_list.py)
  endif()
endif()

unique(types "${WRAP_ITK_SCALAR};UC")
# signed char can't be used to store an image with values up to 255
list(REMOVE_ITEM types SC)
foreach(d ${ITK_WRAP_IMAGE_DIMS})
  foreach(t ${types})
    itk_python_add_test(
      NAME
      PythonSimplePipeline${t}${d}
      TEST_DRIVER_ARGS
      --compare
      ${ITK_TEST_OUTPUT_DIR}/simple_pipeline${t}${d}.nrrd
      DATA{${WrapITK_SOURCE_DIR}/images/cthead1.png}
      COMMAND
      ${CMAKE_CURRENT_SOURCE_DIR}/simple_pipeline.py
      ${t}
      ${d}
      DATA{${WrapITK_SOURCE_DIR}/images/cthead1.png}
      ${ITK_TEST_OUTPUT_DIR}/simple_pipeline${t}${d}.nrrd)
  endforeach()
endforeach()

# Test the lazyloading in a multiprocessing environment
itk_python_add_test(
  NAME
  PythonMultiprocessLazyLoad
  COMMAND
  ${CMAKE_CURRENT_SOURCE_DIR}/multiprocess_lazy_loading.py
  DATA{${WrapITK_SOURCE_DIR}/images/cthead1.png}
  DATA{${WrapITK_SOURCE_DIR}/images/templated_pipeline.png}
  DATA{${WrapITK_SOURCE_DIR}/images/2th_cthead1.png})

# Test proper reading and writing of VariableLengthVector
itk_python_add_test(
  NAME
  PythonVLVReadWriteTest
  TEST_DRIVER_ARGS
  --compare
  ${ITK_TEST_OUTPUT_DIR}/TestVLV.seg.nrrd
  DATA{${WrapITK_SOURCE_DIR}/images/TestVLV.seg.nrrd}
  COMMAND
  ${CMAKE_CURRENT_SOURCE_DIR}/readWriteVLV.py
  DATA{${WrapITK_SOURCE_DIR}/images/TestVLV.seg.nrrd}
  ${ITK_TEST_OUTPUT_DIR}/TestVLV.seg.nrrd
  59
  85
  58
  5)

=== debian/changelog ===
insighttoolkit5 (5.4.5-2) unstable; urgency=medium

  * Team upload.
  * Fix clean target. Closes: #1047043.
  * Fix lintian error "library-not-linked-against-libc".
  * Drop "Rules-Requires-Root: no" (default).
  * Drop "Priority: optional" (default).
  * Update standards-version.
  * Simplify salsa-ci.yml.

 -- Santiago Vila <sanvila@debian.org>  Mon, 02 Mar 2026 21:06:00 +0100

insighttoolkit5 (5.4.5-1) unstable; urgency=medium

  [ Steve Robbins ]
  * [d84a33f] New upstream version 5.4.5
  * [1818b1a] Updated source procedure
  * [3a7be70] Update VER_REVISION

 -- Steve M. Robbins <smr@debian.org>  Sat, 13 Dec 2025 15:36:51 -0600

=== debian/control ===
Source: insighttoolkit5
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Steve M. Robbins <smr@debian.org>,
           Gert Wollny <gewo@debian.org>,
           Étienne Mollier <emollier@debian.org>
Section: science
Build-Depends: debhelper-compat (= 13),
               cmake,
               libvtk9-dev, libvtk9-qt-dev,
               zlib1g-dev,
               libdouble-conversion-dev,
               libexpat-dev,
               libpng-dev,
               libtiff-dev,
               libfftw3-dev,
               libdcmtk-dev,
               libgdcm-dev,
               libgtest-dev,
               uuid-dev,
               libminc-dev,
               libnifti2-dev,
               libhdf5-dev
Standards-Version: 4.7.3
Vcs-Browser: https://salsa.debian.org/med-team/insighttoolkit
Vcs-Git: https://salsa.debian.org/med-team/insighttoolkit.git
Homepage: http://www.itk.org/

Package: libinsighttoolkit5.4
Architecture: amd64
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Image processing toolkit for registration and segmentation - runtime
 ITK is an open-source software toolkit for performing registration and
 segmentation. Segmentation is the process of identifying and
 classifying data found in a digitally sampled
 representation. Typically the sampled representation is an image
 acquired from such medical instrumentation as CT or MRI
 scanners. Registration is the task of aligning or developing
 correspondences between data. For example, in the medical
 environment, a CT scan may be aligned with a MRI scan in order to
 combine the information contained in both.
 .
 This package contains the libraries needed to run ITK applications.

Package: libinsighttoolkit5-dev
Architecture: amd64
Section: libdevel
Depends: ${shlibs:Depends},
         ${misc:Depends},
         libinsighttoolkit5.4 (= ${binary:Version}),
         libvtk9-dev, libvtk9-qt-dev,
         libgdcm-dev,
         libdcmtk-dev,
         libhdf5-dev,
         libdouble-conversion-dev,
         libexpat-dev,
         libnifti-dev,
         libminc-dev
Recommends: libfftw3-dev,
            uuid-dev
Suggests: insighttoolkit5-examples
Conflicts: libinsighttoolkit-dev,
           libinsighttoolkit3-dev,
           libinsighttoolkit4-dev
Replaces: libinsighttoolkit-dev,
          libinsighttoolkit3-dev,
          libinsighttoolkit4-dev
Description: Image processing toolkit for registration and segmentation - development
 ITK is an open-source software toolkit for performing registration and
 segmentation. Segmentation is the process of identifying and
 classifying data found in a digitally sampled
 representation. Typically the sampled representation is an image
 acquired from such medical instrumentation as CT or MRI
 scanners. Registration is the task of aligning or developing
 correspondences between data. For example, in the medical
 environment, a CT scan may be aligned with a MRI scan in order to
 combine the information contained in both.
 .
 This package contains the development files needed to build your own
 ITK applications.

Package: insighttoolkit5-examples
Architecture: all
Section: devel
Depends: ${misc:Depends},
         ${shlibs:Depends}
Suggests: libinsighttoolkit5-dev
Multi-Arch: foreign
Description: Image processing toolkit for registration and segmentation - examples
 ITK is an open-source software toolkit for performing registration and
 segmentation. Segmentation is the process of identifying and
 classifying data found in a digitally sampled
 representation. Typically the sampled representation is an image
 acquired from such medical instrumentation as CT or MRI
 scanners. Registration is the task of aligning or developing
 correspondences between data. For example, in the medical
 environment, a CT scan may be aligned with a MRI scan in order to
 combine the information contained in both.
 .
 This package contains the source for example programs.

=== debian/rules ===
#!/usr/bin/make -f

VER_MAJOR = 5
VER_MINOR = 4
VER_REVISION = 5
VERSION = $(VER_MAJOR).$(VER_MINOR).$(VER_REVISION)
SOVERSION = $(VER_MAJOR).$(VER_MINOR)

#ITK is not properly using system provided headers
export DEB_CPPFLAGS_MAINT_APPEND = -I/usr/include/nifti -g1

ENABLE_FFTW=ON
ENABLE_UNSIGNED_LONG_LONG=ON

ifeq ($(DEB_HOST_ARCH),i386)
  ENABLE_FFTW=OFF
#(unsigned long) == (unsigned int) on 32 bit, since itk 4.10 or g++-5.4
  ENABLE_UNSIGNED_LONG_LONG=OFF
  DEB_CMAKEFLAGS_MAINT_APPEND = -DITK_COMPUTER_MEMORY_SIZE=2
  # Tests are permanently failing, try force rounding to normal double
  # accuracy
  export DEB_CXXFLAGS_MAINT_APPEND=-ffloat-store
endif

CMAKE_FLAGS = \
	-DBUILD_EXAMPLES:BOOL=ON \
	-DBUILD_SHARED_LIBS:BOOL=ON \
	-DBUILD_TESTING:BOOL=ON \
	-DExternalData_OBJECT_STORES:PATH=$(CURDIR)/data/.ExternalData/ \
	-DCMAKE_EXPORT_COMPILE_COMMANDS:BOOL=ON \
	-DCMAKE_SKIP_INSTALL_RPATH:BOOL=ON \
	-DCMAKE_VERBOSE_MAKEFILE:BOOL=ON \
	-DUSE_FFTWF=$(ENABLE_FFTW) \
	-DITK_FORBID_DOWNLOADS:BOOL=ON \
	-DITK_USE_FFTWD:BOOL=$(ENABLE_FFTW) \
	-DITK_USE_FFTWF:BOOL=$(ENABLE_FFTW) \
	-DITK_USE_SYSTEM_DCMTK:BOOL=ON \
	-DITK_USE_SYSTEM_DOUBLECONVERSION:BOOL=OFF \
	-DITK_USE_SYSTEM_EXPAT:BOOL=ON \
	-DITK_USE_SYSTEM_FFTW:BOOL=$(ENABLE_FFTW) \
	-DITK_USE_SYSTEM_GDCM:BOOL=ON \
	-DITK_USE_SYSTEM_GOOGLETEST:BOOL=ON \
	-DGTEST_SRC=/usr/src/googletest/googletest \
	-DITK_USE_SYSTEM_MINC:BOOL=ON \
	-DITK_USE_SYSTEM_HDF5:BOOL=ON \
	-DITK_USE_SYSTEM_JPEG:BOOL=ON \
	-DITK_USE_SYSTEM_PNG:BOOL=ON \
	-DITK_USE_SYSTEM_TIFF:BOOL=OFF \
	-DITK_USE_SYSTEM_VXL:BOOL=OFF \
	-DITK_USE_SYSTEM_ZLIB:BOOL=ON \
	-DITK_USE_KWSTYLE:BOOL=OFF \
	-DModule_ITKDCMTK:BOOL=ON \
	-DModule_ITKIOPhilipsREC:BOOL=OFF \
	-DModule_ITKLevelSetsv4Visualization:BOOL=OFF \
	-DModule_BridgeNumPy:BOOL=OFF \
	-DModule_ITKVideoBridgeOpenCV:BOOL=OFF \
	-DModule_ITKVideoBridgeVXL:BOOL=OFF \
	-DModule_ITKVtkGlue:BOOL=ON \
	-DModule_ITKReview:BOOL=ON \
	-DVCL_INCLUDE_CXX_0X:BOOL=ON \
	-DITK_USE_SYSTEM_SWIG:BOOL=ON \
	-DITK_USE_SYSTEM_CASTXML:BOOL=ON \
	-DITK_WRAP_IMAGE_DIMS="2;3" \
	-DITK_WRAP_unsigned_long_long:BOOL=$(ENABLE_UNSIGNED_LONG_LONG) \
	-DITK_WRAP_double:BOOL=ON \
	-DITK_WRAP_vector_double:BOOL=ON \
	-DITK_WRAP_covariant_vector_double:BOOL=ON \
	-DITK_WRAP_complex_double:BOOL=ON \
	-DITK_COMPUTER_MEMORY_SIZE:STRING="2" \
	$(DEB_CMAKEFLAGS_MAINT_APPEND)

pkg_lib = libinsighttoolkit$(SOVERSION)
pkg_dev = libinsighttoolkit$(VER_MAJOR)-dev
pkg_examples = insighttoolkit$(VER_MAJOR)-examples


%:
	dh $@ --builddir=BUILD

override_dh_auto_configure-indep:

override_dh_auto_configure-arch: pre-build
	dh_auto_configure -- $(CMAKE_FLAGS)

override_dh_auto_build-indep:

pre-build:
	echo "Available disk space (~50GB of space is needed for the build):"
	df -h .

override_dh_auto_test-indep:

override_dh_auto_test:
	LD_LIBRARY_PATH=`pwd`/BUILD/lib:`pwd`/BUILD/Testing/Temporary ARGS="--label-exclude REQUIRES_DISPLAY" dh_auto_test || \
    ( echo "Test log begin =========:"  \
    && cat `pwd`/BUILD/Testing/Temporary/LastTest.log \
    && echo "Test log end =========:" \
    && exit 1 )

override_dh_lintian:
	echo "#ITK embeds various patched libraries" > debian/$(pkg_lib).lintian-overrides
	echo "$(pkg_lib): embedded-library" > debian/$(pkg_lib).lintian-overrides
	echo "$(pkg_lib): package-name-doesnt-match-sonames" >> debian/$(pkg_lib).lintian-overrides
	echo "$(pkg_lib): shared-library-lacks-prerequisites" >> debian/$(pkg_lib).lintian-overrides
	echo "${pkg_dev}: no-manual-page [usr/bin/itkTestDriver]" > debian/$(pkg_dev).lintian-overrides
	dh_lintian

override_dh_install-indep:

override_dh_install-arch:
	# pkg_lib
	dh_install -p$(pkg_lib) --autodest -XJava -XPython -XTcl debian/tmp/usr/lib/*/lib*.so.*
	cp CMake/InsightValgrind.supp Insight$(SOVERSION)Valgrind.supp
#	cp Modules/ThirdParty/VNL/src/vxl/config/valgrind.supp Insight$(SOVERSION)VxlValgrind.supp
	dh_install -p$(pkg_lib) Insight$(SOVERSION)*.supp usr/lib/valgrind
	#
	# pkg_dev
	dh_installman -p$(pkg_dev) debian/insighttoolkit.3
	dh_install -p$(pkg_dev) --autodest -XJava -XPython -XTcl debian/tmp/usr/lib/*/lib*.so
	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/include/ITK-$(SOVERSION)/*
	# The itkTestDriver seems to be required due to references in /usr/lib/cmake files; c.f. Bug #700723
	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/bin/itkTestDriver

	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/lib/*/cmake
	# remove build directory to save space
	rm -rf BUILD debian/tmp

override_dh_installexamples:
	# pkg_examples
	dh_installexamples -p$(pkg_examples) Examples/*
ifneq (,$(filter $(pkg_examples), $(shell dh_listpackages)))
	find debian/$(pkg_examples)/usr/share/doc/$(pkg_examples)/examples \
	    -type f -print0 | xargs -0 chmod 644
endif

override_dh_clean:
	# Modules/ThirdParty/pygccxml/src/pygccxml leaves build artifacts around
	find  Modules/ThirdParty/pygccxml/src -name __pycache__ -execdir rm -r '{}' +
	dh_clean

control-file:
	sed -e "s/@VER_MAJOR@/$(VER_MAJOR)/g" \
	    -e "s/@SOVERSION@/$(SOVERSION)/g" \
	    < debian/control.in > debian/control.tmp
	[ -e debian/control ] \
	  && cmp -s debian/control debian/control.tmp \
	  && rm -f debian/control.tmp && exit 0; \
	  mv debian/control.tmp debian/control

# The Debian source tarball is created by combining the upstream source and data tarballs
# This was done manually:
#
# 1. Download manually:
#    a. https://github.com/InsightSoftwareConsortium/ITK/releases/download/v5.4.5/InsightToolkit-5.4.5.tar.gz
#    b. https://github.com/InsightSoftwareConsortium/ITK/releases/download/v5.4.5/InsightData-5.4.5.tar.gz
#
# 2. Extract in "tarballs", create new merged source tarball:
#    mv ~/Downloads/Insight* .
#    tar xzf InsightToolkit-5.4.5.tar.gz
#    tar xzf InsightData-5.4.5.tar.gz
#    tar --xz -cf insighttoolkit5_5.4.5.orig.tar.xz InsightToolkit-5.4.5
#
# 3. Import into GIT
#    gbp import-orig --pristine-tar ../tarballs/insighttoolkit5_5.4.5.orig.tar.xz
